HDU-1301Jungle Roads

Problem Description
The Head Elder of the tropical island of Lagrishan has a problem. A burst of foreign aid money was spent on extra roads between villages some years ago. But the jungle overtakes roads relentlessly, so the large road network is too expensive to maintain. The Council of Elders must choose to stop maintaining some roads. The map above on the left shows all the roads in use now and the cost in aacms per month to maintain them. Of course there needs to be some way to get between all the villages on maintained roads, even if the route is not as short as before. The Chief Elder would like to tell the Council of Elders what would be the smallest amount they could spend in aacms per month to maintain roads that would connect all the villages. The villages are labeled A through I in the maps above. The map on the right shows the roads that could be maintained most cheaply, for 216 aacms per month. Your task is to write a program that will solve such problems.
The input consists of one to 100 data sets, followed by a final line containing only 0. Each data set starts with a line containing only a number n, which is the number of villages, 1 < n < 27, and the villages are labeled with the first n letters of the alphabet, capitalized. Each data set is completed with n-1 lines that start with village labels in alphabetical order. There is no line for the last village. Each line for a village starts with the village label followed by a number, k, of roads from this village to villages with labels later in the alphabet. If k is greater than 0, the line continues with data for each of the k roads. The data for each road is the village label for the other end of the road followed by the monthly maintenance cost in aacms for the road. Maintenance costs will be positive integers less than 100. All data fields in the row are separated by single blanks. The road network will always allow travel between all the villages. The network will never have more than 75 roads. No village will have more than 15 roads going to other villages (before or after in the alphabet). In the sample input below, the first data set goes with the map above.
The output is one integer per line for each data set: the minimum cost in aacms per month to maintain a road system that connect all the villages. Caution: A brute force solution that examines every possible set of roads will not finish within the one minute time limit.
 
Sample Input
9 A 2 B 12 I 25 B 3 C 10 H 40 I 8 C 2 D 18 G 55 D 1 E 44 E 2 F 60 G 38 F 0 G 1 H 35 H 1 I 35 3 A 2 B 10 C 40 B 1 C 20 0
 
Sample Output
216 30
 
 
解题报告:很明显,此题是一个最小生成树的题目,有两种算法可以解这道题,一种是prime,另一种是克鲁斯卡尔算法,都是解最小生成树问题的算法,两种算法的区别是
首先在时间复杂度上差异很大,prime的时间复杂度是n*n,而克鲁斯卡尔算法的时间复杂度为n*logn;所以这就决定了我们在用的时候选择的问题,一般在解点较多的
最小生成树问题时,多采用克鲁斯卡尔算法,而在解点较少的问题的时候,一般选择用prime算法来解,它的优点是代码简单容易实现,而克鲁斯卡尔算法中用到了一个并查集的知识,所以要使用克鲁斯卡尔算法,必须要先熟悉并查集的知识。而克鲁斯卡尔算法的优点除了时间复杂度低一点之外,还有一个很突出的优点就是它可以记录路径,当问题要求要得出解决问题的路径时,用prime算法就显得无能为力了,而用克鲁斯卡尔算法可以很方便的记录解决问题的路径。下面具体的AC代码:
 
#include<iostream>
#include<stdio.h>
using namespace std;
int visit[85];
int N,sum;
struct node {
 int front,rear;
 int length;
}lode[85];
int find(int i,int x) {
 return (i==x? x:find(x,visit[x]));
}
void popsort(int n) {
 for(int i=1;i<=n;++i)
 for(int j=1;j<=n-1;++j)
 if(lode[j].length>lode[j+1].length) {
  struct node d=lode[j];
  lode[j]=lode[j+1];
  lode[j+1]=d;
 }
}
int main() {
 char jungle[5],jun[3];
 int n;
  while(scanf("%d",&N)&&N!=0) {
   sum=0;
   int z=1;
   for(int i=1;i<N;++i) {
    scanf("%s%d",jun,&n);
    if(n==0)
     continue;
    for(int j=1;j<=n;++j) {
     scanf("%s%d",jungle,&lode[z].length);
     lode[z].front=jun[0]-65+1;
     lode[z++].rear=jungle[0]-65+1;
    }
   }
   for(int i=1;i<=N;++i)        //对visist数组进行初始化
    visit[i]=i;
   popsort(z-1);
   int jishu=0;
  for(int i=1;i<=z;++i)
   if(find(lode[i].front,visit[lode[i].front])!=find(lode[i].rear,visit[lode[i].rear])) {
    if(jishu>=N-1)
    break;
    jishu++;
    visit[find(lode[i].front,visit[lode[i].front])]=lode[i].rear;
    sum+=lode[i].length;
  }
  printf("%d\n",sum);
 }
 return 0;
}

转载于:https://www.cnblogs.com/xiaxiaosheng/archive/2013/04/19/3031497.html

主要内容:本文详细介绍了一种QRBiLSTM(分位数回归双向长短期记忆网络)的时间序列区间预测方法。首先介绍了项目背景以及模型的优势,比如能够有效利用双向的信息,并对未来的趋势上限和下限做出估计。接着从数据生成出发讲述了具体的代码操作过程:数据预处理,搭建模型,进行训练,并最终可视化预测结果与计算分位数回归的边界线。提供的示例代码可以完全运行并且包含了数据生成环节,便于新手快速上手,深入学习。此外还指出了模型未来发展的方向,例如加入额外的输入特性和改善超参数配置等途径提高模型的表现。文中强调了时间序列的标准化和平稳检验,在样本划分阶段需要按时间序列顺序进行划分,并在训练阶段采取合适的手段预防过度拟合发生。 适合人群:对于希望学习和应用双向长短时记忆网络解决时序数据预测的初学者和具有一定基础的研究人员。尤其适用于有金融数据分析需求、需要做多一步或多步预测任务的从业者。 使用场景及目标:应用于金融市场波动预报、天气状况变化预测或是物流管理等多个领域内的决策支持。主要目的在于不仅能够提供精确的数值预计还能描绘出相应的区间概率图以增强结论置信程度。 补充说明:本教程通过一个由正弦信号加白噪构造而成的简单实例来指导大家理解和执行QRBiLSTM流程的所有关键步骤,这既方便于初学者跟踪学习,又有利于专业人士作为现有系统的补充参考工具。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值